/* *****************************************************************************
 * File:        dogl.h
 * Project:     Mini Anzeige Modul
 * Author:      Nicolas Meyertns
 * Version:     1.0.xc8
 * Web:         www.PIC-Projekte.de
 * ****************************************************************************/

#ifndef DOGL_H
#define	DOGL_H

/*Pinbelegung*/
#define SI          LATCbits.LC5    // SDO1 (MSSP1)
#define CLK         LATCbits.LC3    // SCK1 (MSSP1)
#define A0          LATAbits.LA2    // Daten/Kommandos - Display
#define CS1B        LATAbits.LA0    // Low aktiv!
#define RST         LATAbits.LA1    // Low aktiv!

#define FONTWIDTH   font[(*pChain)-32][0]
/*Display..*/
#define INVERSE     true
#define NOINVERSE   false
#define COMMAND     0
#define DATA        1
/*Kontrast.*/
#define INCREASE    true
#define DECREASE    false

#define DEFAULT_CONTRAST    16

/*Typ Definitionen*/
typedef unsigned char bool;
typedef unsigned char uint8_t;

/*Prototypen*/
uint8_t sendSPI (uint8_t byte);
void initDOGL(uint8_t *pContrast);
void clearDOGL(void);
void charChainDOGL(uint8_t page, uint8_t column, bool inverse, const uint8_t *pChain);
void drawSignDOGL(uint8_t page, uint8_t column, bool inverse, uint8_t signIdex);
void setAddrDOGL(uint8_t page, uint8_t column);
void setContrastDOGL(bool increase, uint8_t *pContrast);

#endif	/* DOGL_H */