/* *****************************************************************************
 * File:        isr.c
 * Project:     Mini Anzeige Modul
 * Author:      Nicolas Meyertns
 * Version:     1.xc8
 * Web:         www.PIC-Projekte.de
 * ****************************************************************************/

#include <xc.h>
#include "isr.h"
#include "setup.h"

/*Interrupt mit hoher Prioritt*/
void interrupt highPrio(void)
{

}

/*Interrupt mit niedriger Prioritt*/
void interrupt low_priority lowPrio(void)
{
    if(INTCONbits.TMR0IF)
    {
        /*Prfen ob und welcher Taster gedrckt wurde*/
        switch( keyPressed(&lastKeyDown) )
        {
            case KEY_OK:        input |= KEY_OK;
                                break;
        }
        
        /*Prfen ob und in welche Richtung der Drehgeber gedreht wurde*/
        switch( encoder() )
        {
            case KEY_UP:        input |= KEY_UP;
                                break;
            case KEY_DOWN:      input |= KEY_DOWN;
                                break;
        }
        
        INTCONbits.TMR0IF=0;
    }
}
