/* *****************************************************************************
 * File:        main.c
 * Project:     Mini Anzeige Modul
 * Author:      Nicolas Meyertns
 * Version:     0.1.a.xc8
 * Web:         www.PIC-Projekte.de
 * ****************************************************************************/

#ifndef MAIN_H
#define	MAIN_H

/*LCD Makros*/
#define SI          LATCbits.LC5    // SDO1 (MSSP1)
#define CLK         LATCbits.LC3    // SCK1 (MSSP1)
#define A0          LATAbits.LA2    // Daten/Kommandos - Display
#define CS1B        LATAbits.LA0    // Low aktiv!
#define RST         LATAbits.LA1    // Low aktiv!


/*Allgemeine Makros*/
#define _XTAL_FREQ  4000000         // Clock frequency in Hz
#define true        1
#define false       0
#define ARRAY_SIZE(x)  (sizeof(x)/sizeof(*x))

/*Tasten Makros*/
#define NO_KEY      0
#define KEY_OK      1
#define KEY_UP      2
#define KEY_DOWN    4

/*Typ Definitionen*/
typedef unsigned char bool;
typedef unsigned char uint8_t;

/*Variablen*/
extern uint8_t input;
extern uint8_t lastKeyDown;
extern uint8_t encState;

/*Prototypen*/
void initPIC (void);
void initSPI (void);
void configPWM(void);
uint8_t sendSPI (uint8_t byte);

#endif	/* MAIN_H */