/* *****************************************************************************
 * File:        menu.c
 * Project:     Mini Anzeige Modul
 * Author:      Nicolas Meyertns
 * Version:     0.1.a.xc8
 * Web:         www.PIC-Projekte.de
 * ****************************************************************************/

#include <xc.h>
#include "menu.h"
#include "isr.h"
#include "font.h"
#include "dogl.h"

/*
 * Ein Men
 */
void mControll (uint8_t menuSize, struct sMenuEntry menu[])
{
    uint8_t active = 0;
    bool running;

    drawMenu(menuSize, menu);
    drawBar("Einstellungen");
    charChainDOGL(active+2,0,NOINVERSE,">");

    running = true;

    while(running)
    {
        if( input & KEY_OK )
        {
            input &= ~KEY_OK;
            if( menu[active].function != 0 )
            {
                clearDOGL();
                menu[active].function();
                drawMenu(menuSize, menu);
                drawBar("Einstellungen");
                charChainDOGL(active+2,0,NOINVERSE,">");
            }
            else
            {
                running = false;
            }
        }
        else if( input & KEY_UP )
        {
            input &= ~KEY_UP;
            /*Geht es hher?*/
            if( active > 0)
            {
                charChainDOGL(active+2, 0, NOINVERSE, "  ");
                active--;
                charChainDOGL(active+2, 0, NOINVERSE, ">");
            }
        }
        else if( input & KEY_DOWN )
        {
            input &= ~KEY_DOWN;
            /*Geht es tiefer?*/
            if( active < (menuSize-1) )
            {
                charChainDOGL(active+2, 0, NOINVERSE, "  ");
                active++;
                charChainDOGL(active+2, 0, NOINVERSE, ">");
            }
        }
    }
}

/*
 * Diese Funktion schreibt die einzelnen Menpunkte eines Mens
 *
 * menuSize:    Anzahl der Menpunkte
 * sMenuEntry:  Zeiger auf die Struktur mit den Menpunkten
 */
void drawMenu(uint8_t menuSize, struct sMenuEntry menu[])
{
    uint8_t k;

    clearDOGL();
    for( k=0; k < menuSize; k++ )
        charChainDOGL(k+2,5,NOINVERSE,menu[k].text);
}

/*
 * Diese Funktion schreibt die Statusbar mit variablen Text
 *
 * pName: Der Text, welcher in der Statusbar stehen soll
 */
void drawBar(const uint8_t *pName)
{
    uint8_t k=0;

    charChainDOGL(0, 0, INVERSE, pName);

    while(*pName)
    {
        k += font[(*pName)-32][0];
        pName++;
    }

    while( k < 128 )
    {
        sendSPI(0xFF);
        k++;
    }
    /*Dies sollte noch dynamisch gestaltet werden!*/
    drawSignDOGL(0,122,INVERSE,BAT_FULL);
}